#!/bin/bash
#-----------------------------------------------------------------------------#
# Section Gods v1.1 by Turranius. Thanks to JanG for the USERTOP line.        #
# http://www.grandis.nu/glftpd/   ( turranius@hotmail.com )                   #
#-----------------------------------------------------------------------------#
# Installation:                                                               #
# Set the parameters below as follows:                                        #
# ROOTDIR=      The root dir of your site folder.                             # 
# PASSWD=       The full path to your passwd file                             #
# NOCOUNT=      Set this to whatever your missing files includes. We dont     #
#               count anything with this included. Usually "missing"          #
# SECTIONS=     Important part. What are the names, and where is that folder? #
#               Setting it to, for instance, apps:ISO-UTILS will cause it to  #
#               check in ROOTDIR/ISO-UTILS for files when someone types       #
#               '!gods apps' in the channel.                                  #
#               The name (first part) is not case sensitive, so '!gods APPS'  #
#               works just as well from irc.                                  #
#               Separate the name and path with a ':' and separate sections   #
#               with a space, like the example.                               #
#                                                                             #
# Copy the .sh to glftpd's bin folder and make sure its executable for the    #
# user that runs the bot.                                                     #
# If it runs from shell, it should run from the bot as well.                  #
#                                                                             #
# Make sure the user that runs the bot have read permissions on passwd file!  #
# Copy the .tcl to your bots /scripts folder and load it in the bots config   #
# file. Rehash the bot, and try !gods from irc (trigger !gods can be changed  #
# in the tcl script).                                                         #
#-----------------------------------------------------------------------------#
# You may copy and change this script as much as you like.                    #
#-----------------------------------------------------------------------------#
# Changelog:                                                                  #
# 1.1 : Add: Rewrote how sections work. Easier to setup now.                  #
#       Add: Name is no longer case sensitive.                                #
#       Add: NOCOUNT added to exclude a certain type of file from counting.   #
# 1.0 : Initial release.                                                      #
#-----------------------------------------------------------------------------#

ROOTDIR=/glftpd/site
PASSWD=/glftpd/etc/passwd
NOCOUNT="missing"
SECTIONS="divx:DIVX svcd:SVCD utils:ISO-UTILS vcd:VCD xxx:XXX oldsvcd:Archive/SVCD"


###################################################################
# No changes below here needed                                    #
###################################################################

if [ -z "$1" ]; then
  NAMESECTIONS=""
  for name in $SECTIONS; do
    thisname="$( echo $name | awk -F":" '{print $1}' )"
    if [ "$NAMESECTIONS" = "" ]; then
      NAMESECTIONS="$thisname"
    else
      NAMESECTIONS="$NAMESECTIONS, $thisname"
    fi
  done
  echo "Display the uploading Gods of CURRENT files. You must select a section. Valid ones are $NAMESECTIONS."
  exit 0
fi

for section in $SECTIONS; do
  name="$( echo $section | awk -F":" '{print $1}' )"
  path="$( echo $section | awk -F":" '{print $2}' )"
  VERIFY=""
  VERIFY="$( echo $1 | grep -w -i $name )"
  if [ "$VERIFY" != "" ]; then
    goto="$path"
  fi
done

if [ "$goto" = "" ]; then
  NAMESECTIONS=""
  for name in $SECTIONS; do
    thisname="$( echo $name | awk -F":" '{print $1}' )"
    if [ "$NAMESECTIONS" = "" ]; then
      NAMESECTIONS="$thisname"
    else
      NAMESECTIONS="$NAMESECTIONS, $thisname"
    fi
  done
  echo "$1 is not a valid section. Valid sections are $NAMESECTIONS."
  exit 0
fi

if [ -e $ROOTDIR/$goto ]; then
  cd $ROOTDIR/$goto
else
  echo "$goto does not exist. Bug siteops to fix this."
  exit 0
fi

USERTOP="$(ls -lR | egrep -iv "$NOCOUNT" | grep '^-rw' | awk '{print $3}' | sort | uniq -c | sort -nr)"

NR1uid="$(echo $USERTOP | awk -F" " '{print $2}')"
NR2uid="$(echo $USERTOP | awk -F" " '{print $4}')"
NR3uid="$(echo $USERTOP | awk -F" " '{print $6}')"
NR4uid="$(echo $USERTOP | awk -F" " '{print $8}')"
NR5uid="$(echo $USERTOP | awk -F" " '{print $10}')"

NR1files="$(echo $USERTOP | awk -F" " '{print $1}')"
NR2files="$(echo $USERTOP | awk -F" " '{print $3}')"
NR3files="$(echo $USERTOP | awk -F" " '{print $5}')"
NR4files="$(echo $USERTOP | awk -F" " '{print $7}')"
NR5files="$(echo $USERTOP | awk -F" " '{print $9}')"

if [ "$NR1uid" = "root" ]; then
  NR1uid="0"
fi
if [ "$NR2uid" = "root" ]; then
  NR2uid="0"
fi
if [ "$NR3uid" = "root" ]; then
  NR3uid="0"
fi
if [ "$NR4uid" = "root" ]; then
  NR4uid="0"
fi
if [ "$NR5uid" = "root" ]; then
  NR5uid="0"
fi

NR1USR="$(cat $PASSWD | grep :$NR1uid: | awk -F":" '{print $1}')"
if [ -z "$NR1USR" ]; then
  NR1USR="*DELETED*"
fi
NR2USR="$(cat $PASSWD | grep :$NR2uid: | awk -F":" '{print $1}')"
if [ -z "$NR2USR" ]; then
  NR2USR="*DELETED*"
fi
NR3USR="$(cat $PASSWD | grep :$NR3uid: | awk -F":" '{print $1}')"
if [ -z "$NR3USR" ]; then
  NR3USR="*DELETED*"
fi
NR4USR="$(cat $PASSWD | grep :$NR4uid: | awk -F":" '{print $1}')"
if [ -z "$NR4USR" ]; then
  NR4USR="*DELETED*"
fi
NR5USR="$(cat $PASSWD | grep :$NR5uid: | awk -F":" '{print $1}')"
if [ -z "$NR5USR" ]; then
  NR5USR="*DELETED*"  
fi

NOGOD="No Gods at all in $goto section!"
HEADR="$goto Gods:"
TEXT1="#1: $NR1USR with $NR1files files!"
TEXT2="- #2: $NR2USR with $NR2files files!"
TEXT3="- #3: $NR3USR with $NR3files files!"
TEXT4="- #4: $NR4USR with $NR4files files!"
TEXT5="- #5: $NR5USR with $NR5files files!"

if [ "$NR5USR" != "*DELETED*" ]; then
  echo "$HEADR $TEXT1 $TEXT2 $TEXT3 $TEXT4 $TEXT5"
  exit 0
fi

if [ "$NR5USR" = "*DELETED*" ]; then
  if [ "$NR4USR" = "*DELETED*" ]; then
    if [ "$NR3USR" = "*DELETED*" ]; then
      if [ "$NR2USR" = "*DELETED*" ]; then
        if [ "$NR1USR" = "*DELETED*" ]; then
          echo "$NOGOD"
          exit 0
        else
          echo "$HEADR $TEXT1"
          exit 0
        fi
      else
        echo "$HEADR $TEXT1 $TEXT2"
        exit 0
      fi
    else
      echo "$HEADR $TEXT1 $TEXT2 $TEXT3"
      exit 0
    fi
  else
    echo "$HEADR $TEXT1 $TEXT2 $TEXT3 $TEXT4"
    exit 0
  fi
fi  

exit 0
